//
//  PreviewView.m
//  Fast Draft
//
//  Created by Anton on 13.03.13.
//  Copyright (c) 2013 Geometros Company. All rights reserved.
//

#import "PreviewView.h"
#import "QuartzCore/QuartzCore.h"


#import "CommonStructs.h"


@implementation PreviewView
{
    UIImage*    mainBckgrLightImage;
    PreviewDrawer*      drawLayer;
}

- (id)initWithCoder:(NSCoder*)aDecoder
{
    self = [super initWithCoder:aDecoder];
    if (self) {
        
        self.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"blueprintGrid.png"]];
        self.contentMode = UIViewContentModeRedraw;

        mainBckgrLightImage = [UIImage imageNamed:@"blueprintLight.png"];

        
        drawLayer = [[PreviewDrawer alloc] init];
        
        CALayer *mylayer = [CALayer layer];
        mylayer.frame = CGRectMake(0, 0, self.bounds.size.width, self.bounds.size.height);
        mylayer.delegate = drawLayer;
        [self.layer addSublayer:mylayer];
        [mylayer setNeedsDisplay];
        
    }
    return self;
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    [[self.layer.sublayers objectAtIndex:0] setFrame:self.bounds];
    [self redrawPreview];
}

-(void)   redrawPreview
{
    [[self.layer.sublayers objectAtIndex:0]  setNeedsDisplay];
}

// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    [mainBckgrLightImage drawInRect:rect];
}


@end



/*****************************/
@implementation PreviewDrawer

- (id)init
{
    self = [super init];
    if (self) {
        
    }
    return self;
}

-(void) drawLayer: (CALayer*) layer inContext: (CGContextRef) context
{
    
    [Drawer ApplyStyleToContext:context];
    
    CGContextSetRGBStrokeColor(context, 1.0f, 1.0f, 1.0f, 1.0f);
    CGContextSetLineCap(context, kCGLineCapRound);
    
    
    CGRect  rct = layer.frame;
    
    CGContextBeginPath(context);
    
    for (int i=0; i<5; i++)
    {
      CGContextMoveToPoint(context, 20, 2*rct.size.height/3 + i*30);
      CGContextAddLineToPoint(context, rct.size.width-20, 2*rct.size.height/3+ i*30);
    }
    
    CGContextStrokePath(context);
    
    SG_ARC  tmpArc;
    SG_POINT  begP = {50, 2*rct.size.height/3, 0};
    SG_POINT  endP = {rct.size.width-50, 2*rct.size.height/3, 0};
    SG_POINT  midP = {rct.size.width/2, 50, 0};
    
    tmpArc.FromThreePoints(begP, endP, midP, false);
    
    [Drawer DrawArc:&tmpArc inContext:context];
    
    [Drawer  DrawText:@"Preview" onContext:context fromPoint:CGPointMake(rct.size.width/2, rct.size.height/2) withAlignToCenter:YES];
    
}

@end
